

public class Blake {

	private static final int[] IV32 = { 0x6A09E667, 0xBB67AE85, 0x3C6EF372, 0xA54FF53A, 0x510E527F,
			0x9B05688C, 0x1F83D9AB, 0x5BE0CD19 };
	private static final int[][] sigma = { { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 },
			{ 14, 10, 4, 8, 9, 15, 13, 6, 1, 12, 0, 2, 11, 7, 5, 3 },
			{ 11, 8, 12, 0, 5, 2, 15, 13, 10, 14, 3, 6, 7, 1, 9, 4 },
			{ 7, 9, 3, 1, 13, 12, 11, 14, 2, 6, 5, 10, 4, 0, 15, 8 },
			{ 9, 0, 5, 7, 2, 4, 10, 15, 14, 1, 11, 12, 6, 8, 3, 13 },
			{ 2, 12, 6, 10, 0, 11, 8, 3, 4, 13, 7, 5, 15, 14, 1, 9 },
			{ 12, 5, 1, 15, 14, 13, 4, 10, 0, 7, 6, 3, 9, 2, 8, 11 },
			{ 13, 11, 7, 14, 12, 1, 3, 9, 5, 0, 15, 4, 8, 6, 2, 10 },
			{ 6, 15, 14, 9, 11, 3, 0, 8, 12, 2, 13, 7, 1, 4, 10, 5 },
			{ 10, 2, 8, 4, 7, 6, 1, 5, 15, 11, 9, 14, 3, 12, 13, 0 },
			{ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 },
			{ 14, 10, 4, 8, 9, 15, 13, 6, 1, 12, 0, 2, 11, 7, 5, 3 },
			{ 11, 8, 12, 0, 5, 2, 15, 13, 10, 14, 3, 6, 7, 1, 9, 4 },
			{ 7, 9, 3, 1, 13, 12, 11, 14, 2, 6, 5, 10, 4, 0, 15, 8 },
			{ 9, 0, 5, 7, 2, 4, 10, 15, 14, 1, 11, 12, 6, 8, 3, 13 },
			{ 2, 12, 6, 10, 0, 11, 8, 3, 4, 13, 7, 5, 15, 14, 1, 9 },
			{ 12, 5, 1, 15, 14, 13, 4, 10, 0, 7, 6, 3, 9, 2, 8, 11 },
			{ 13, 11, 7, 14, 12, 1, 3, 9, 5, 0, 15, 4, 8, 6, 2, 10 },
			{ 6, 15, 14, 9, 11, 3, 0, 8, 12, 2, 13, 7, 1, 4, 10, 5 },
			{ 10, 2, 8, 4, 7, 6, 1, 5, 15, 11, 9, 14, 3, 12, 13, 0 } };
	private static final int[] c32 = { 0x243F6A88, 0x85A308D3, 0x13198A2E, 0x03707344, 0xA4093822,
			0x299F31D0, 0x082EFA98, 0xEC4E6C89, 0x452821E6, 0x38D01377, 0xBE5466CF, 0x34E90C6C, 0xC0AC29B7,
			0xC97C50DD, 0x3F84D5B5, 0xB5470917 };
	private static final byte[] padding = { (byte) 0x80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };

	private static int datalen, nullt;
	private static boolean extraPadding;

	private static int[] h32 = new int[8];
	private static byte[] data32 = new byte[64];

	private static int[] t32 = new int[2];
	private static int[] v = new int[16];
	private static int[] m = new int[16];
	
	public static void Init() {

		System.arraycopy(IV32, 0, h32, 0, 8);
		t32[0] = 0; t32[1] = 0;
		nullt = 0;

	}
	
	public static void Update(byte[] data, long databitlen) {

		int left, fill, pointer = extraPadding ? 1 : 0;

		if (databitlen == 0)
			return;
		left = (datalen >>> 3);
		fill = 64 - left;
		if ((left != 0) && (((databitlen >>> 3) & 0x3F) >= fill)) {
			System.arraycopy(data, pointer, data32, left, fill);
			t32[0] += 512;
			if (t32[0] == 0)
				t32[1]++;
			compress(data32, 0);
			pointer += fill;
			databitlen -= (fill << 3);
			left = 0;
		}
		while (databitlen >= 512) {
			t32[0] += 512;
			if (t32[0] == 0)
				t32[1]++;
			compress(data, pointer);
			pointer += 64;
			databitlen -= 512;
		}
		if (databitlen > 0) {
			System.arraycopy(data, pointer, data32, left, (int) (databitlen >>> 3));
			datalen = (int) ((left << 3) + databitlen);
			if ((databitlen & 0x7) != 0)
				data32[(int) (left + (databitlen >>> 3))] = data[(int) (databitlen >>> 3) + pointer];
		} else
			datalen = 0;

	}

	private static void compress(byte[] datablock, int pointer) {

		int offset = extraPadding ? pointer-- : pointer;

		m[0] = U8TO32_BE(datablock, 0 + offset);
		m[1] = U8TO32_BE(datablock, 4 + offset);
		m[2] = U8TO32_BE(datablock, 8 + offset);
		m[3] = U8TO32_BE(datablock, 12 + offset);
		m[4] = U8TO32_BE(datablock, 16 + offset);
		m[5] = U8TO32_BE(datablock, 20 + offset);
		m[6] = U8TO32_BE(datablock, 24 + offset);
		m[7] = U8TO32_BE(datablock, 28 + offset);
		m[8] = U8TO32_BE(datablock, 32 + offset);
		m[9] = U8TO32_BE(datablock, 36 + offset);
		m[10] = U8TO32_BE(datablock, 40 + offset);
		m[11] = U8TO32_BE(datablock, 44 + offset);
		m[12] = U8TO32_BE(datablock, 48 + offset);
		m[13] = U8TO32_BE(datablock, 52 + offset);
		m[14] = U8TO32_BE(datablock, 56 + offset);
		m[15] = U8TO32_BE(datablock, 60 + offset);

		v[0] = h32[0]; v[1] = h32[1];
		v[2] = h32[2]; v[3] = h32[3];
		v[4] = h32[4]; v[5] = h32[5];
		v[6] = h32[6]; v[7] = h32[7];
		v[8] = c32[0]; v[9] = c32[1];
		v[10] = c32[2];v[11] = c32[3];
		
		if (nullt != 0) {
			v[12] = c32[4]; v[13] = c32[5];
			v[14] = c32[6];	v[15] = c32[7];
		} else {
			v[12] = t32[0] ^ c32[4]; v[13] = t32[0] ^ c32[5];
			v[14] = t32[1] ^ c32[6]; v[15] = t32[1] ^ c32[7];
		}

		for (int round = 0; round < 10; ++round) {

			G32(0, 4, 8, 12, 0, round);	 G32(1, 5, 9, 13, 1, round);
			G32(2, 6, 10, 14, 2, round); G32(3, 7, 11, 15, 3, round);
			G32(0, 5, 10, 15, 4, round); G32(1, 6, 11, 12, 5, round);
			G32(2, 7, 8, 13, 6, round);  G32(3, 4, 9, 14, 7, round);
		}

		h32[0] ^= v[0] ^ v[8];  h32[1] ^= v[1] ^ v[9];
		h32[2] ^= v[2] ^ v[10]; h32[3] ^= v[3] ^ v[11];
		h32[4] ^= v[4] ^ v[12]; h32[5] ^= v[5] ^ v[13];
		h32[6] ^= v[6] ^ v[14]; h32[7] ^= v[7] ^ v[15];

	}

	public static void Final(byte[] hashval) {

		byte[] msglen = new byte[8];
		int low, high;
		byte[] zo = { 0x01 }, oo = { (byte) 0x81 };

		low = t32[0] + datalen;
		high = t32[1];
		if (low < datalen)
			high++;
		U32TO8_BE(msglen, 0, high);
		U32TO8_BE(msglen, 4, low);
		if (datalen % 8 == 0) {
			if (datalen == 440) {
				t32[0] -= 8;
				Update(oo, 8);
			} else {
				if (datalen < 440) {
					t32[0] -= (440 - datalen);
					Update(padding, (440 - datalen));
					if (datalen == 0)
						nullt = 1;
				} else {
					t32[0] -= (512 - datalen);
					Update(padding, (512 - datalen));
					t32[0] -= 440;
					extraPadding = true;
					Update(padding, 440);
					extraPadding = false;
					nullt = 1;
				}

				Update(zo, 8);
				t32[0] -= 8;
			}
			t32[0] -= 64;
			Update(msglen, 64);
		} else {
			data32[datalen / 8] &= (0xFF << (8 - datalen % 8));
			data32[datalen / 8] ^= (0x80 >>> (datalen % 8));
			if ((datalen > 440) && (datalen < 447)) {
				data32[datalen / 8] ^= 0x01;
				t32[0] -= (8 - (datalen % 8));
				datalen = (int) ((datalen & 0xfffffffffffffff8L) + 8);
			} else {
				if (datalen < 440) {
					t32[0] -= 440 - datalen;
					datalen = (int) ((datalen & 0xfffffffffffffff8L) + 8);
					extraPadding = true;
					Update(padding, 440 - datalen);
					extraPadding = false;
				} else {
					t32[0] -= 512 - datalen;
					datalen = (int) ((datalen & 0xfffffffffffffff8L) + 8);
					extraPadding = true;
					Update(padding, 512 - datalen);
					t32[0] -= 440;
					Update(padding, 440);
					nullt = 1;
					extraPadding = false;
				}
				t32[0] -= 8;
				Update(zo, 8);
			}
			t32[0] -= 64;
			Update(msglen, 64);
		}

		U32TO8_BE(hashval, 0, h32[0]);  U32TO8_BE(hashval, 4, h32[1]);
		U32TO8_BE(hashval, 8, h32[2]);  U32TO8_BE(hashval, 12, h32[3]);
		U32TO8_BE(hashval, 16, h32[4]); U32TO8_BE(hashval, 20, h32[5]);
		U32TO8_BE(hashval, 24, h32[6]); U32TO8_BE(hashval, 28, h32[7]);

	}

	public static void Hash(byte[] data, long databitlen, byte[] hashval) {

		Init();
		Update(data, databitlen);
		Final(hashval);

	}
	
	private static int ROT32(int x, int n) {
		return (x << 32 - n) | (x >>> n);
	}

	private static int ADD32(int x, int y) {
		return (int) (x + y);
	}

	private static int XOR32(int x, int y) {
		return (int) (x ^ y);
	}

	private static void G32(int a, int b, int c, int d, int i, int round) {
		v[a] = ADD32(v[a], v[b]) + XOR32(m[sigma[round][2 * i]], c32[sigma[round][2 * i + 1]]);
		v[d] = ROT32(XOR32(v[d], v[a]), 16);
		v[c] = ADD32(v[c], v[d]);
		v[b] = ROT32(XOR32(v[b], v[c]), 12);
		v[a] = ADD32(v[a], v[b]) + XOR32(m[sigma[round][2 * i + 1]], c32[sigma[round][2 * i]]);
		v[d] = ROT32(XOR32(v[d], v[a]), 8);
		v[c] = ADD32(v[c], v[d]);
		v[b] = ROT32(XOR32(v[b], v[c]), 7);
	}

	private static int U8TO32_BE(byte[] p, int offset) {
		return (((p[0 + offset] & 255) << 24) | ((p[1 + offset] & 255) << 16) | ((p[2 + offset] & 255) << 8) | ((p[3 + offset] & 255)));
	}

	private static void U32TO8_BE(byte[] p, int offset, int v) {
		p[0 + offset] = (byte) (v >>> 24);
		p[1 + offset] = (byte) (v >>> 16);
		p[2 + offset] = (byte) (v >>> 8);
		p[3 + offset] = (byte) (v);
	}

}
