public class BlueMidnightWish {

	private static final int BlueMidnightWish256_BLOCK_SIZE = 64, EXPAND_1_ROUNDS = 2, EXPAND_2_ROUNDS = 14;
	private static final int[] i256p2 = { 0x40414243, 0x44454647, 0x48494a4b, 0x4c4d4e4f, 0x50515253,
			0x54555657, 0x58595a5b, 0x5c5d5e5f, 0x60616263, 0x64656667, 0x68696a6b, 0x6c6d6e6f, 0x70717273,
			0x74757677, 0x78797a7b, 0x7c7d7e7f, };

	private static int[] H256 = new int[16];
	private static int[] DoublePipe = new int[16];
	private static byte[] LastPart;
	private static long bits_processed, unprocessed_bits;
	private static int M32Pointer;

	public static void Init() {

		bits_processed = 0;
		System.arraycopy(i256p2, 0, DoublePipe, 0, 16);
		LastPart = new byte[BlueMidnightWish256_BLOCK_SIZE * 2];

	}

	public static void Update(byte[] data, long databitlen) {

		int[] M32 = new int[(data.length)+1/4];

		setM32(M32, data, databitlen);
		System.arraycopy(DoublePipe, 0, H256, 0, DoublePipe.length);
		while (databitlen >= BlueMidnightWish256_BLOCK_SIZE * 8) {
			databitlen -= BlueMidnightWish256_BLOCK_SIZE * 8;
			bits_processed += BlueMidnightWish256_BLOCK_SIZE * 8;
			Compression256(M32, H256);
			System.arraycopy(M32, 16, M32, 0, M32Pointer - 16);
			for (int i = 0; i < 16; i++)
				M32[i + M32Pointer - 16] = 0;
			M32Pointer -= 16;

		}

		unprocessed_bits = databitlen;
		if (databitlen > 0) {
			U8TO32(M32);
		}
	}

	private static void U8TO32(int[] M32) {
		
		int a = 0;
		try {
			for (int i = 0; i < M32.length; i++) {
				LastPart[a++] = (byte)  M32[i];
				LastPart[a++] = (byte) (M32[i] >> 8);
				LastPart[a++] = (byte) (M32[i] >> 16);
				LastPart[a++] = (byte) (M32[i] >> 24);
			}
		} catch (Exception e) {
		}
	}

	private static void setM32(int[] M32, byte[] data, long databitlen) {
		
		int a = 0;
		try {
			for (int i = 0; i < M32.length; i++) {
				M32[i] = (data[a++] & 255) << 0;
				M32[i] |= (data[a++] & 255) << 8;
				M32[i] |= (data[a++] & 255) << 16;
				M32[i] |= (data[a++] & 255) << 24;
			}
		} catch (Exception e) {
		}
		M32Pointer = (int) Math.ceil((double) data.length / 4);
	}

	private static void Compression256(int[] M32, int[] H) {

		int i;
		int XL32, XH32;
		int[] Q = new int[32];
		int[] W = new int[32];

		W[0] = (M32[5] ^ H[5]) - (M32[7] ^ H[7]) + (M32[10] ^ H[10]) + (M32[13] ^ H[13]) + (M32[14] ^ H[14]);
		W[1] = (M32[6] ^ H[6]) - (M32[8] ^ H[8]) + (M32[11] ^ H[11]) + (M32[14] ^ H[14]) - (M32[15] ^ H[15]);
		W[2] = (M32[0] ^ H[0]) + (M32[7] ^ H[7]) + (M32[9] ^ H[9]) - (M32[12] ^ H[12]) + (M32[15] ^ H[15]);
		W[3] = (M32[0] ^ H[0]) - (M32[1] ^ H[1]) + (M32[8] ^ H[8]) - (M32[10] ^ H[10]) + (M32[13] ^ H[13]);
		W[4] = (M32[1] ^ H[1]) + (M32[2] ^ H[2]) + (M32[9] ^ H[9]) - (M32[11] ^ H[11]) - (M32[14] ^ H[14]);
		W[5] = (M32[3] ^ H[3]) - (M32[2] ^ H[2]) + (M32[10] ^ H[10]) - (M32[12] ^ H[12]) + (M32[15] ^ H[15]);
		W[6] = (M32[4] ^ H[4]) - (M32[0] ^ H[0]) - (M32[3] ^ H[3]) - (M32[11] ^ H[11]) + (M32[13] ^ H[13]);
		W[7] = (M32[1] ^ H[1]) - (M32[4] ^ H[4]) - (M32[5] ^ H[5]) - (M32[12] ^ H[12]) - (M32[14] ^ H[14]);
		W[8] = (M32[2] ^ H[2]) - (M32[5] ^ H[5]) - (M32[6] ^ H[6]) + (M32[13] ^ H[13]) - (M32[15] ^ H[15]);
		W[9] = (M32[0] ^ H[0]) - (M32[3] ^ H[3]) + (M32[6] ^ H[6]) - (M32[7] ^ H[7]) + (M32[14] ^ H[14]);
		W[10] = (M32[8] ^ H[8]) - (M32[1] ^ H[1]) - (M32[4] ^ H[4]) - (M32[7] ^ H[7]) + (M32[15] ^ H[15]);
		W[11] = (M32[8] ^ H[8]) - (M32[0] ^ H[0]) - (M32[2] ^ H[2]) - (M32[5] ^ H[5]) + (M32[9] ^ H[9]);
		W[12] = (M32[1] ^ H[1]) + (M32[3] ^ H[3]) - (M32[6] ^ H[6]) - (M32[9] ^ H[9]) + (M32[10] ^ H[10]);
		W[13] = (M32[2] ^ H[2]) + (M32[4] ^ H[4]) + (M32[7] ^ H[7]) + (M32[10] ^ H[10]) + (M32[11] ^ H[11]);
		W[14] = (M32[3] ^ H[3]) - (M32[5] ^ H[5]) + (M32[8] ^ H[8]) - (M32[11] ^ H[11]) - (M32[12] ^ H[12]);
		W[15] = (M32[12] ^ H[12]) - (M32[4] ^ H[4]) - (M32[6] ^ H[6]) - (M32[9] ^ H[9]) + (M32[13] ^ H[13]);

		Q[0] = s32_0(W[0]) + H[1];
		Q[1] = s32_1(W[1]) + H[2];
		Q[2] = s32_2(W[2]) + H[3];
		Q[3] = s32_3(W[3]) + H[4];
		Q[4] = s32_4(W[4]) + H[5];
		Q[5] = s32_0(W[5]) + H[6];
		Q[6] = s32_1(W[6]) + H[7];
		Q[7] = s32_2(W[7]) + H[8];
		Q[8] = s32_3(W[8]) + H[9];
		Q[9] = s32_4(W[9]) + H[10];
		Q[10] = s32_0(W[10]) + H[11];
		Q[11] = s32_1(W[11]) + H[12];
		Q[12] = s32_2(W[12]) + H[13];
		Q[13] = s32_3(W[13]) + H[14];
		Q[14] = s32_4(W[14]) + H[15];
		Q[15] = s32_0(W[15]) + H[0];

		for (i = 0; i < EXPAND_1_ROUNDS; i++)
			Q[i + 16] = expand32_1(i + 16, M32, H, Q);
		for (i = EXPAND_1_ROUNDS; i < EXPAND_1_ROUNDS + EXPAND_2_ROUNDS; i++)
			Q[i + 16] = expand32_2(i + 16, M32, H, Q);

		XL32 = Q[16] ^ Q[17] ^ Q[18] ^ Q[19] ^ Q[20] ^ Q[21] ^ Q[22] ^ Q[23];
		XH32 = XL32 ^ Q[24] ^ Q[25] ^ Q[26] ^ Q[27] ^ Q[28] ^ Q[29] ^ Q[30] ^ Q[31];

		H[0] = (shl(XH32, 5) ^ shr(Q[16], 5) ^ M32[0]) + (XL32 ^ Q[24] ^ Q[0]);
		H[1] = (shr(XH32, 7) ^ shl(Q[17], 8) ^ M32[1]) + (XL32 ^ Q[25] ^ Q[1]);
		H[2] = (shr(XH32, 5) ^ shl(Q[18], 5) ^ M32[2]) + (XL32 ^ Q[26] ^ Q[2]);
		H[3] = (shr(XH32, 1) ^ shl(Q[19], 5) ^ M32[3]) + (XL32 ^ Q[27] ^ Q[3]);
		H[4] = (shr(XH32, 3) ^ Q[20] ^ M32[4]) + (XL32 ^ Q[28] ^ Q[4]);
		H[5] = (shl(XH32, 6) ^ shr(Q[21], 6) ^ M32[5]) + (XL32 ^ Q[29] ^ Q[5]);
		H[6] = (shr(XH32, 4) ^ shl(Q[22], 6) ^ M32[6]) + (XL32 ^ Q[30] ^ Q[6]);
		H[7] = (shr(XH32, 11) ^ shl(Q[23], 2) ^ M32[7]) + (XL32 ^ Q[31] ^ Q[7]);

		H[8] = rotl32(H[4], 9) + (XH32 ^ Q[24] ^ M32[8]) + (shl(XL32, 8) ^ Q[23] ^ Q[8]);
		H[9] = rotl32(H[5], 10) + (XH32 ^ Q[25] ^ M32[9]) + (shr(XL32, 6) ^ Q[16] ^ Q[9]);
		H[10] = rotl32(H[6], 11) + (XH32 ^ Q[26] ^ M32[10]) + (shl(XL32, 6) ^ Q[17] ^ Q[10]);
		H[11] = rotl32(H[7], 12) + (XH32 ^ Q[27] ^ M32[11]) + (shl(XL32, 4) ^ Q[18] ^ Q[11]);
		H[12] = rotl32(H[0], 13) + (XH32 ^ Q[28] ^ M32[12]) + (shr(XL32, 3) ^ Q[19] ^ Q[12]);
		H[13] = rotl32(H[1], 14) + (XH32 ^ Q[29] ^ M32[13]) + (shr(XL32, 4) ^ Q[20] ^ Q[13]);
		H[14] = rotl32(H[2], 15) + (XH32 ^ Q[30] ^ M32[14]) + (shr(XL32, 7) ^ Q[21] ^ Q[14]);
		H[15] = rotl32(H[3], 16) + (XH32 ^ Q[31] ^ M32[15]) + (shr(XL32, 2) ^ Q[22] ^ Q[15]);

	}

	private static int expand32_1(int i, int[] M32, int[] H, int[] Q) {
		return (s32_1(Q[i - 16]) + s32_2(Q[i - 15]) + s32_3(Q[i - 14]) + s32_0(Q[i - 13]) + s32_1(Q[i - 12])
				+ s32_2(Q[i - 11]) + s32_3(Q[i - 10]) + s32_0(Q[i - 9]) + s32_1(Q[i - 8]) + s32_2(Q[i - 7])
				+ s32_3(Q[i - 6]) + s32_0(Q[i - 5]) + s32_1(Q[i - 4]) + s32_2(Q[i - 3]) + s32_3(Q[i - 2])
				+ s32_0(Q[i - 1]) + ((i * (0x05555555) + rotl32(M32[(i - 16) % 16], ((i - 16) % 16) + 1)
				+ rotl32(M32[(i - 13) % 16], ((i - 13) % 16) + 1) - rotl32(M32[(i - 6) % 16],
				((i - 6) % 16) + 1)) ^ H[(i - 16 + 7) % 16]));
	}

	private static int expand32_2(int i, int[] M32, int[] H, int[] Q) {
		return (Q[i - 16] + r32(Q[i - 15], 3) + Q[i - 14] + r32(Q[i - 13], 7) + Q[i - 12]
				+ r32(Q[i - 11], 13) + Q[i - 10] + r32(Q[i - 9], 16) + Q[i - 8] + r32(Q[i - 7], 19)
				+ Q[i - 6] + r32(Q[i - 5], 23) + Q[i - 4] + r32(Q[i - 3], 27) + s32_4(Q[i - 2])
				+ s32_5(Q[i - 1]) + ((i * (0x05555555) + rotl32(M32[(i - 16) % 16], ((i - 16) % 16) + 1)
				+ rotl32(M32[(i - 13) % 16], ((i - 13) % 16) + 1) - rotl32(M32[(i - 6) % 16],
				((i - 6) % 16) + 1)) ^ H[(i - 16 + 7) % 16]));
	}

	public static void Final(byte[] hashval) {

		int[] M32 = new int[32];
		int databitlen;
		int PadOnePosition, LastByte;
		int[] CONST32final = { 0xaaaaaaa0, 0xaaaaaaa1, 0xaaaaaaa2, 0xaaaaaaa3, 0xaaaaaaa4, 0xaaaaaaa5,
				0xaaaaaaa6, 0xaaaaaaa7, 0xaaaaaaa8, 0xaaaaaaa9, 0xaaaaaaaa, 0xaaaaaaab, 0xaaaaaaac,
				0xaaaaaaad, 0xaaaaaaae, 0xaaaaaaaf };

		LastByte = (int) (unprocessed_bits >> 3);
		PadOnePosition = (int) (7 - (unprocessed_bits & 0x07));
		LastPart[LastByte] = (byte) ((LastPart[LastByte] & (0xff << (PadOnePosition + 1))) ^ (0x01 << PadOnePosition));
		setM32(M32, LastPart, (LastByte + 1) * 8);
		if (unprocessed_bits < 448) {
			databitlen = BlueMidnightWish256_BLOCK_SIZE * 8;
			M32[14] = (int) (bits_processed + unprocessed_bits);
		} else {
			databitlen = BlueMidnightWish256_BLOCK_SIZE * 16;
			M32[30] = (int) (bits_processed + unprocessed_bits);
		}
		System.arraycopy(H256, 0, DoublePipe, 0, 16);
		while (databitlen >= BlueMidnightWish256_BLOCK_SIZE * 8) {
			databitlen -= BlueMidnightWish256_BLOCK_SIZE * 8;
			Compression256(M32, H256);
			System.arraycopy(M32, 16, M32, 0, M32Pointer - 16);
			for (int i = 0; i < 16; i++)
				M32[i + M32Pointer - 16] = 0;
			M32Pointer -= 16;
		}
		Compression256(H256, CONST32final);
		int index = 0;
		for (int i = 8; i < 16; i++) {
			hashval[index++] = (byte) (255 & CONST32final[i]);
			hashval[index++] = (byte) (255 & CONST32final[i] >> 8);
			hashval[index++] = (byte) (255 & CONST32final[i] >> 16);
			hashval[index++] = (byte) (255 & CONST32final[i] >> 24);
		}

	}

	public static void Hash(byte[] data, long databitlen, byte[] hashval) {

		Init();
		Update(data, databitlen);
		Final(hashval);

	}	
	
	private static int rotl32(int x, int n) {
		return ((x << n) | (x >>> (32 - n)));
	}

	private static int shl(int x, int n) {
		return (x << n);
	}

	private static int shr(int x, int n) {
		return (x >>> n);
	}

	private static int s32_0(int x) {
		return (shr((x), 1) ^ shl((x), 3) ^ rotl32((x), 4) ^ rotl32((x), 19));
	}

	private static int s32_1(int x) {
		return (shr((x), 1) ^ shl((x), 2) ^ rotl32((x), 8) ^ rotl32((x), 23));
	}

	private static int s32_2(int x) {
		return (shr((x), 2) ^ shl((x), 1) ^ rotl32((x), 12) ^ rotl32((x), 25));
	}

	private static int s32_3(int x) {
		return (shr((x), 2) ^ shl((x), 2) ^ rotl32((x), 15) ^ rotl32((x), 29));
	}

	private static int s32_4(int x) {
		return (shr((x), 1) ^ (x));
	}

	private static int s32_5(int x) {
		return (shr((x), 2) ^ (x));
	}

	private static int r32(int x, int v) {
		return rotl32(x, v);
	}	
	
	
}