public class CubeHash {

	private static final int[] mybit = new int[] { 128, 64, 32, 16, 8, 4, 2, 1 };

	private static int x[][][][][];
	private static int state[] = new int[128];
	private static int block[] = new int[32];
	private static int blockbits;

	public static void Init() {

		x  = new int[2][2][2][2][2];
		x[0][0][0][0][0] = 32;
		x[0][0][0][0][1] = 32;
		x[0][0][0][1][0] = 16;

		for (int i = 0; i < 10; ++i)
			rrounds();

		blockbits = 0;

	}

	private static void rrounds() {
		
		int tmp = 0;
		for (int r = 0; r < 16; ++r) {
			for (int j = 0; j < 2; ++j)
				for (int k = 0; k < 2; ++k)
					for (int l = 0; l < 2; ++l)
						for (int m = 0; m < 2; ++m)
							x[1][j][k][l][m] += x[0][j][k][l][m];
			for (int j = 0; j < 2; ++j)
				for (int k = 0; k < 2; ++k)
					for (int l = 0; l < 2; ++l)
						for (int m = 0; m < 2; ++m)
							x[0][j][k][l][m] = rotateUpwards7(x[0][j][k][l][m]);
			for (int k = 0; k < 2; ++k) {
				for (int l = 0; l < 2; ++l) {
					for (int m = 0; m < 2; ++m) {
						tmp = x[0][0][k][l][m];
						x[0][0][k][l][m] = x[0][1][k][l][m];
						x[0][1][k][l][m] = tmp;
					}
				}
			}
			for (int j = 0; j < 2; ++j)
				for (int k = 0; k < 2; ++k)
					for (int l = 0; l < 2; ++l)
						for (int m = 0; m < 2; ++m)
							x[0][j][k][l][m] ^= x[1][j][k][l][m];
			for (int j = 0; j < 2; ++j) {
				for (int k = 0; k < 2; ++k) {
					for (int m = 0; m < 2; ++m) {
						tmp = x[1][j][k][0][m];
						x[1][j][k][0][m] = x[1][j][k][1][m];
						x[1][j][k][1][m] = tmp;
					}
				}
			}
			for (int j = 0; j < 2; ++j)
				for (int k = 0; k < 2; ++k)
					for (int l = 0; l < 2; ++l)
						for (int m = 0; m < 2; ++m)
							x[1][j][k][l][m] += x[0][j][k][l][m];
			for (int j = 0; j < 2; ++j)
				for (int k = 0; k < 2; ++k)
					for (int l = 0; l < 2; ++l)
						for (int m = 0; m < 2; ++m)
							x[0][j][k][l][m] = rotateUpwards11(x[0][j][k][l][m]);
			for (int j = 0; j < 2; ++j) {
				for (int l = 0; l < 2; ++l) {
					for (int m = 0; m < 2; ++m) {
						tmp = x[0][j][0][l][m];
						x[0][j][0][l][m] = x[0][j][1][l][m];
						x[0][j][1][l][m] = tmp;
					}
				}
			}
			for (int j = 0; j < 2; ++j)
				for (int k = 0; k < 2; ++k)
					for (int l = 0; l < 2; ++l)
						for (int m = 0; m < 2; ++m)
							x[0][j][k][l][m] ^= x[1][j][k][l][m];
			for (int j = 0; j < 2; ++j) {
				for (int k = 0; k < 2; ++k) {
					for (int l = 0; l < 2; ++l) {
						tmp = x[1][j][k][l][0];
						x[1][j][k][l][0] = x[1][j][k][l][1];
						x[1][j][k][l][1] = tmp;
					}
				}
			}

		}
		
	}

	private static void updatebit(int nextbit) {

		block[blockbits / 8] &= ~mybit[blockbits % 8];
		block[blockbits / 8] |= nextbit * mybit[blockbits % 8];
		blockbits++;
		if (blockbits < 256)
			return;
		xToState();
		for (int j = 0; j < 32; ++j)
			state[j] ^= block[j];
		xFromState();
		blockbits = 0;
		rrounds();
		
	}

	public static void Update(byte[] data, long databitlen) {

		int nextbit;
		for (int i = 0; i < databitlen; ++i) {
			nextbit = (data[i / 8] & mybit[i % 8]) / mybit[i % 8];
			updatebit(nextbit);
		}
	}

	public static void Final(byte[] hashval) {

		updatebit(1);
		while (blockbits != 0)
			updatebit(0);
		x[1][1][1][1][1] ^= 1;
		for (int i = 0; i < 10; ++i)
			rrounds();
		xToState();
		for (int i = 0; i < 32; ++i)
			hashval[i] = (byte) (state[i]);

	}

	public static void Hash(byte[] data, long databitlen, byte[] hashval) {

		Init();
		Update(data, databitlen);
		Final(hashval);
	}

	private static void xToState() {

		int a = 0;

		for (int i = 0; i < 2; ++i) {
			for (int j = 0; j < 2; ++j) {
				for (int k = 0; k < 2; ++k) {
					for (int l = 0; l < 2; ++l) {
						for (int m = 0; m < 2; ++m) {
							state[a++] = 255 & x[i][j][k][l][m];
							state[a++] = 255 & x[i][j][k][l][m] >> 8;
							state[a++] = 255 & x[i][j][k][l][m] >> 16;
							state[a++] = 255 & x[i][j][k][l][m] >> 24;

						}
					}
				}
			}
		}
	}

	private static void xFromState() {

		int a = 0;
		for (int i = 0; i < 2; ++i) {
			for (int j = 0; j < 2; ++j) {
				for (int k = 0; k < 2; ++k) {
					for (int l = 0; l < 2; ++l) {
						for (int m = 0; m < 2; ++m) {
							int value;
							value = state[a++] << 0;
							value |= state[a++] << 8;
							value |= state[a++] << 16;
							value |= state[a++] << 24;
							x[i][j][k][l][m] = value;
						}
					}
				}
			}
		}
	}

	private static int rotateUpwards7(int i) {
		return ((i << 7) | (i >>> 25));
	}

	private static int rotateUpwards11(int i) {
		return ((i << 11) | (i >>> 21));
	}
}
