package candidates;

public class Fugue {

	private static final int[] Cfg = { 8, 30, 2, 5, 13 }; /* n, s, k, r, t */

	private static long TotalBits;
	private static int Base;
	private static int[] Partial;
	private static int[] IV;
	private static byte[] aessub = new byte[256];
	private static byte init_fugue;
	private static GF2MUL[] gf2mul;

	private static M[] m;
	private static M[] State;

	private static byte gf_0(int x) {
		return 0;
	}

	private static byte gf_1(int x) {
		return (byte) x;
	}

	private static byte gf_2(int x) {
		return (byte) ((x << 1) ^ ((x >> 7 & 1) * 0x11b));
	}

	private static byte gf_3(int x) {
		return (byte) (gf_2(x) ^ gf_1(x));
	}

	private static byte gf_4(int x) {
		return gf_2(gf_2(x));
	}

	private static byte gf_5(int x) {
		return (byte) (gf_4(x) ^ gf_1(x));
	}

	private static byte gf_6(int x) {
		return (byte) (gf_4(x) ^ gf_2(x));
	}

	private static byte gf_7(int x) {
		return (byte) (gf_4(x) ^ gf_2(x) ^ gf_1(x));
	}

	private static int HO2BE_4(int _x) {
		return ((_x << 24) | ((_x << 8) & 0xff0000) | ((_x >>> 8) & 0xff00) | (_x >>> 24));
	}

	private static long HO2BE_8(long _x) {
		return ((_x << 56) | ((_x << 40) & 0xff000000000000L) | ((_x << 24) & 0xff0000000000L)
				| ((_x << 8) & 0xff00000000L) | ((_x >>> 8) & 0xff000000L) | ((_x >>> 24) & 0xff0000L)
				| ((_x >>> 40) & 0xff00L) | (_x >>> 56));
	}

	private static int COLUMN(int col) {
		int x = Base + col;
		return (x < Cfg[1] ? x : x - Cfg[1]);
	}

	private static void ROTATE(int r) {
		Base = COLUMN(Cfg[1] - r);
	}

	private static byte BYTES(int _r, int _c) {
		return State[COLUMN(_c)].b[_r];
	}

	private static int cdiv(int _n, int _d) {
		return ((_n + _d - 1) / _d);
	}

	public static void Init() {
		gf2mul = new GF2MUL[256];
		m = new M[4];
		State = new M[32];
		TotalBits = 0;
		init_fugue = 0;
		
		IV = new int[16];
		Partial = new int[2];
		            
		for (int j = 0; j < gf2mul.length; j++)
			gf2mul[j] = new GF2MUL();
		for (int j = 0; j < m.length; j++)
			m[j] = new M();
		for (int j = 0; j < State.length; j++)
			State[j] = new M();

		Make_Fugue();
		int n = Cfg[0];
		int s = Cfg[1];

		for (int i = 0; i < State.length; i++) {
			State[i].d = 0;
			State[i].syncFromInt();
		}
		for (int i = (s - n); i < State.length; i++) {
			State[i].d = IV[i - (s - n)];
			State[i].syncFromInt();
		}
		Base = 0;

	}

	private static void Make_Fugue() {
		int j, k, sb;
		int[] X = new int[8];
		int[] SB = new int[256];

		if (init_fugue != 0)
			return;
		init_fugue = 1;

		SB[0] = 0;
		SB[1] = (1 << 8) | 1;
		for (int i = 2; i < 256; i++) {
			X[0] = i;
			for (j = 1; j < 8; j++)
				if (((X[j] = X[j - 1] << 1) & 256) != 0)
					X[j] ^= 0x11b;
			for (j = 2; j < 256; j++) {
				sb = 0;
				for (k = 0; k < 8; k++)
					if ((j & (1 << k)) != 0)
						sb ^= X[k];
				if (sb == 1)
					break;
			}
			SB[i] = (j << 8) | j;
		}
		for (int i = 0; i < 256; i++) {

			aessub[i] = (byte) (SB[i] ^ 0x63);
			for (j = 4; j < 8; j++)
				aessub[i] ^= (SB[i] >> j);

			gf2mul[i].b[0] = gf_0(i);
			gf2mul[i].b[1] = gf_1(i);
			gf2mul[i].b[2] = gf_2(i);
			gf2mul[i].b[3] = gf_3(i);
			gf2mul[i].b[4] = gf_4(i);
			gf2mul[i].b[5] = gf_5(i);
			gf2mul[i].b[6] = gf_6(i);
			gf2mul[i].b[7] = gf_7(i);

		}

		m[0].b[0] = 1;	m[1].b[0] = 4;	m[2].b[0] = 7;
		m[3].b[0] = 1;	m[0].b[1] = 1;	m[1].b[1] = 1;
		m[2].b[1] = 4;	m[3].b[1] = 7;  m[0].b[2] = 7;
		m[1].b[2] = 1;  m[2].b[2] = 1;	m[3].b[2] = 4;
		m[0].b[3] = 4;	m[1].b[3] = 7;	m[2].b[3] = 1;
		m[3].b[3] = 1;
		
		Fugue_IV();
	}

	private static void Fugue_IV() {

		int Data[] = { HO2BE_4(Cfg[0] * 32), 0 };
		Next_Fugue(Data, 1);
		Done_Fugue(IV);
	}

	private static void Next_Fugue(final int[] msg, long len) {

		int index = 0;
		while (len-- != 0) {
			Input_Mix(msg[index++]);
			for (int k = 0; k < Cfg[2]; k++) {
				ROR3_Col_Mix();
				for (int i = 0; i < State.length; i++)
					State[i].syncFromInt();
				Super_Mix();
				for (int i = 0; i < State.length; i++)
					State[i].syncFromByte();
			}
		}
	}

	private static void Done_Fugue(int[] md) {

		int n = Cfg[0];	int s = Cfg[1];
		int k = Cfg[2];	int r = Cfg[3];
		int t = Cfg[4];	
		int N = cdiv(n, 4);
		int p = s / N;

		for (int j = 0; j < r * k; j++) {
			ROR3_Col_Mix();
			for (int i = 0; i < State.length; i++)
				State[i].syncFromInt();
			Super_Mix();
			for (int i = 0; i < State.length; i++)
				State[i].syncFromByte();
		}

		switch (N) {
		case 1:
			for (int j = 0; j < t; j++) {
				Col_Xor_RORn(s - 1, 0, 0, 0);
				for (int i = 0; i < State.length; i++)
					State[i].syncFromInt();
				Super_Mix();
				for (int i = 0; i < State.length; i++)
					State[i].syncFromByte();
			}
			Col_Xor(0, 0, 0);
			break;
		case 2:
			for (int j = 0; j < t; j++) {
				Col_Xor_RORn(p, p, 0, 0);
				for (int i = 0; i < State.length; i++)
					State[i].syncFromInt();
				Super_Mix();
				for (int i = 0; i < State.length; i++)
					State[i].syncFromByte();
				Col_Xor_RORn(p - 1, p + 1, 0, 0);
				for (int i = 0; i < State.length; i++)
					State[i].syncFromInt();
				Super_Mix();
				for (int i = 0; i < State.length; i++)
					State[i].syncFromByte();
			}
			Col_Xor(p, 0, 0);
			break;
		case 3:
			for (int j = 0; j < t; j++) {
				Col_Xor_RORn(p, p, 2 * p, 0);
				for (int i = 0; i < State.length; i++)
					State[i].syncFromInt();
				Super_Mix();
				for (int i = 0; i < State.length; i++)
					State[i].syncFromByte();
				Col_Xor_RORn(p, p + 1, 2 * p, 0);
				for (int i = 0; i < State.length; i++)
					State[i].syncFromInt();
				Super_Mix();
				for (int i = 0; i < State.length; i++)
					State[i].syncFromByte();
				Col_Xor_RORn(p - 1, p + 1, 2 * p + 1, 0);
				for (int i = 0; i < State.length; i++)
					State[i].syncFromInt();
				Super_Mix();
				for (int i = 0; i < State.length; i++)
					State[i].syncFromByte();
			}
			Col_Xor(p, 2 * p, 0);
			break;
		case 4:
			for (int j = 0; j < t; j++) {
				Col_Xor_RORn(p, p, 2 * p, 3 * p);
				for (int i = 0; i < State.length; i++)
					State[i].syncFromInt();
				Super_Mix();
				for (int i = 0; i < State.length; i++)
					State[i].syncFromByte();
				Col_Xor_RORn(p, p + 1, 2 * p, 3 * p);
				for (int i = 0; i < State.length; i++)
					State[i].syncFromInt();
				Super_Mix();
				for (int i = 0; i < State.length; i++)
					State[i].syncFromByte();
				Col_Xor_RORn(p, p + 1, 2 * p + 1, 3 * p);
				for (int i = 0; i < State.length; i++)
					State[i].syncFromInt();
				Super_Mix();
				for (int i = 0; i < State.length; i++)
					State[i].syncFromByte();
				Col_Xor_RORn(p - 1, p + 1, 2 * p + 1, 3 * p + 1);
				for (int i = 0; i < State.length; i++)
					State[i].syncFromInt();
				Super_Mix();
				for (int i = 0; i < State.length; i++)
					State[i].syncFromByte();
			}
			Col_Xor(p, 2 * p, 3 * p);
			break;
		}

		int index = 0;
		for (int j = 0; j < 4 && j < n; j++)
			md[index++] = State[COLUMN(j + 1)].d;
		for (r = 1; r <= N - 2; r++)
			for (int j = 0; j < 4; j++)
				md[index++] = State[COLUMN(r * p + j)].d;
		if (n > 4)
			for (int j = 0; j + r * 4 < n; j++)
				md[index++] = State[COLUMN(s - p + j)].d;

	}

	private static void Input_Mix(int sc) {

		int s = Cfg[1];
		int k = Cfg[2];

		State[COLUMN(6 * k - 2)].d ^= State[COLUMN(0)].d;
		State[COLUMN(0)].d = sc;
		State[COLUMN(8)].d ^= sc;
		for (int i = 0; i <= k - 2; i++)
			State[COLUMN(3 * i + 1)].d ^= State[COLUMN(s - 3 * k + 3 * i)].d;
	}

	private static void ROR3_Col_Mix() {
		int s = Cfg[1];

		ROTATE(3);
		for (int i = 0; i < 3; i++) {
			State[COLUMN(i)].d ^= State[COLUMN(4 + i)].d;
			State[COLUMN(s / 2 + i)].d ^= State[COLUMN(4 + i)].d;
		}
	}

	private static void Super_Mix() {
		M[] U = new M[4];
		for (int i = 0; i < U.length; i++)
			U[i] = new M();
		M D = new M();
		M[] W = new M[4];
		for (int i = 0; i < W.length; i++)
			W[i] = new M();
		int r, c;

		for (r = 0; r < 4; r++)
			for (c = 0; c < 4; c++)
				U[c].b[r] = aessub[BYTES(r, c) & 255];

		for (r = 0; r < 4; r++)
			for (c = 0; c < 4; c++)
				if (r != c)
					D.b[r] ^= U[c].b[r];

		for (r = 0; r < 4; r++)
			for (c = 0; c < 4; c++)
				W[c].b[r] = (byte) (gf2mul[U[c].b[0] & 255].b[m[0].b[r] & 255]
						^ gf2mul[U[c].b[1] & 255].b[m[1].b[r] & 255]
						^ gf2mul[U[c].b[2] & 255].b[m[2].b[r] & 255]
						^ gf2mul[U[c].b[3] & 255].b[m[3].b[r] & 255] ^ gf2mul[D.b[r] & 255].b[m[r].b[c] & 255] & 255);

		for (r = 0; r < 4; r++)
			for (c = 0; c < 4; c++)
				State[COLUMN((c - r) & 3)].b[r] = W[c].b[r];
	}

	private static void Col_Xor_RORn(int ror, int a, int b, int c) {
		Col_Xor(a, b, c);
		ROTATE(ror);
	}

	private static void Col_Xor(int a, int b, int c) {
		State[COLUMN(4)].d ^= State[COLUMN(0)].d;
		if (a != 0)
			State[COLUMN(a)].d ^= State[COLUMN(0)].d;
		if (b != 0)
			State[COLUMN(b)].d ^= State[COLUMN(0)].d;
		if (c != 0)
			State[COLUMN(c)].d ^= State[COLUMN(0)].d;
	}

	private static void setData32(int[] data32, byte[] data, long databitlen) {
		int a = 0;
		try {
			for (int i = 0; i < data32.length; i++) {
				data32[i] = (data[a++] & 255) << 0;
				data32[i] |= (data[a++] & 255) << 8;
				data32[i] |= (data[a++] & 255) << 16;
				data32[i] |= (data[a++] & 255) << 24;
			}
		} catch (Exception e) {
		}
	}

	public static void Update(byte[] data, long databitlen) {

		if (databitlen == 0)
			return;
		int[] data32 = new int[(int) Math.ceil((double) data.length / 4)];
		setData32(data32, data, databitlen);
		int dataPointer = 0;

		if (databitlen > 31) {
			Next_Fugue(data32, databitlen / 32);
			TotalBits += (databitlen / 32) * 32;
			dataPointer += (databitlen / 32) * 4;
			databitlen &= 31;
		}
		if (databitlen != 0) {
			TotalBits += databitlen;
			Partial[0] = data32[data32.length - 1];
		}

	}

	public static void Final(byte[] hashval) {

		int[] hash = new int[8];
		int index;

		if ((TotalBits & 31) != 0) {
			int startIndex = (int) ((TotalBits & 31) / 8);
			switch (startIndex) {
			case 2:
				Partial[0] &= 0xffff;
				break;
			case 1:
				Partial[0] &= 0xff;
				break;
			case 0:
				Partial[0] &= 0;
				break;
			default:
				break;
			}
			Next_Fugue(Partial, 1);
		}
		TotalBits = HO2BE_8(TotalBits);
		int[] TotalBitsArray = { (int) (TotalBits >>> 0), (int) (TotalBits >>> 32) };

		Next_Fugue(TotalBitsArray, 2);
		Done_Fugue(hash);

		index = 0;
		for (int i = 0; i < hash.length; i++) {
			hashval[index++] = (byte) (255 & hash[i]);
			hashval[index++] = (byte) (255 & hash[i] >> 8);
			hashval[index++] = (byte) (255 & hash[i] >> 16);
			hashval[index++] = (byte) (255 & hash[i] >> 24);
		}
	}

	public static void Hash(byte[] data, long databitlen, byte[] hashval) {

		Init();
		Update(data, databitlen);
		Final(hashval);
		
	}

	private static class GF2MUL {
		byte[] b = new byte[8];
	}

	private static class M {
		int d;
		byte[] b = new byte[4];

		private void syncFromByte() {
			int a = 0;
			d = b[a++] & 255;
			d |= (b[a++] & 255) << 8;
			d |= (b[a++] & 255) << 16;
			d |= (b[a++] & 255) << 24;
		}

		private void syncFromInt() {
			int a = 0;
			b[a++] = (byte) (255 & d);
			b[a++] = (byte) (255 & d >> 8);
			b[a++] = (byte) (255 & d >> 16);
			b[a++] = (byte) (255 & d >> 24);
		}

	}

}
