package candidates;

public class Groestl {

	
	private static final int[] S = { 99, 124, 119, 123, 242, 107, 111, 197, 48, 1, 103, 43, 254, 215, 171, 118, 202,
		130, 201, 125, 250, 89, 71, 240, 173, 212, 162, 175, 156, 164, 114, 192, 183, 253, 147, 38, 54,
		63, 247, 204, 52, 165, 229, 241, 113, 216, 49, 21, 4, 199, 35, 195, 24, 150, 5, 154, 7, 18, 128,
		226, 235, 39, 178, 117, 9, 131, 44, 26, 27, 110, 90, 160, 82, 59, 214, 179, 41, 227, 47, 132, 83,
		209, 0, 237, 32, 252, 177, 91, 106, 203, 190, 57, 74, 76, 88, 207, 208, 239, 170, 251, 67, 77,
		51, 133, 69, 249, 2, 127, 80, 60, 159, 168, 81, 163, 64, 143, 146, 157, 56, 245, 188, 182, 218,
		33, 16, 255, 243, 210, 205, 12, 19, 236, 95, 151, 68, 23, 196, 167, 126, 61, 100, 93, 25, 115,
		96, 129, 79, 220, 34, 42, 144, 136, 70, 238, 184, 20, 222, 94, 11, 219, 224, 50, 58, 10, 73, 6,
		36, 92, 194, 211, 172, 98, 145, 149, 228, 121, 231, 200, 55, 109, 141, 213, 78, 169, 108, 86,
		244, 234, 101, 122, 174, 8, 186, 120, 37, 46, 28, 166, 180, 198, 232, 221, 116, 31, 75, 189, 139,
		138, 112, 62, 181, 102, 72, 3, 246, 14, 97, 53, 87, 185, 134, 193, 29, 158, 225, 248, 152, 17,
		105, 217, 142, 148, 155, 30, 135, 233, 206, 85, 40, 223, 140, 161, 137, 13, 191, 230, 66, 104,
		65, 153, 45, 15, 176, 84, 187, 22, };

	private static int[][] chaining;
	private static byte[] buffer = new byte[128];
	private static int buf_ptr;
	private static int block_counter;
	private static int bits_in_last_byte;

	private static int[][] Shift = { { 0, 1, 2, 3, 4, 5, 6, 7 },
			{ 0, 1, 2, 3, 4, 5, 6, 11 } };

	private static byte mul1(int b) {
		return (byte) (b);
	}

	private static byte mul2(int b) {
		return (byte) (((b) >> 7) != 0 ? ((b) << 1) ^ 0x1b : ((b) << 1));
	}

	private static byte mul3(int b) {
		return (byte) (mul2(b) ^ mul1(b));
	}

	private static byte mul4(int b) {
		return mul2(mul2(b));
	}

	private static byte mul5(int b) {
		return (byte) (mul4(b) ^ mul1(b));
	}

	private static byte mul7(int b) {
		return (byte) (mul4(b) ^ mul2(b) ^ mul1(b));
	}

	public static void Hash(byte[] data, long databitlen, byte[] hashval) {

		Init();
		Update(data, databitlen);
		Final(hashval);

	}

	public static void Init() {

		chaining = new int[8][16];
		for (int i = 4; i < 8; i++) {
			chaining[i][8 - 1] = (byte) (256 >> (8 * (7 - i)));
		}
		buf_ptr = 0;
		block_counter = 0;
		bits_in_last_byte = 0;

	}

	public static void Final(byte[] output) {

		int BILB = bits_in_last_byte;

		if (bits_in_last_byte != 0) {
			buffer[buf_ptr - 1] &= ((1 << BILB) - 1) << (8 - BILB);
			buffer[buf_ptr - 1] ^= 0x1 << (7 - BILB);

		} else {
			buffer[buf_ptr++] = (byte) 0x80;

		}

		if (buf_ptr > 64 - 8) {
			while (buf_ptr < 64) {
				buffer[buf_ptr++] = 0;
			}
			Transform(buffer, 64, 0);
			buf_ptr = 0;
		}
		while (buf_ptr < 64 - 8) {
			buffer[buf_ptr++] = 0;
		}

		block_counter++;
		buf_ptr = 64;
		while (buf_ptr > 64 - 8) {
			buffer[--buf_ptr] = (byte) block_counter;
			block_counter >>= 8;
		}

		Transform(buffer, 64, 0);
		OutputTransformation();

		int j = 0;
		for (int i = 32; i < 64; i++) {
			output[j] = (byte) chaining[i % 8][i / 8];
			j++;
		}

		for (int i = 0; i < 8; i++) {
			for (j = 0; j < 8; j++) {
				chaining[i][j] = 0;
			}
		}
		for (int i = 0; i < 64; i++) {
			buffer[i] = 0;
		}

	}

	public static void Update(byte[] input, long databitlen) {

		int index = 0;
		int msglen = (int) (databitlen / 8);
		int rem = (int) (databitlen % 8);

		if (bits_in_last_byte != 0)
			return;

		if (buf_ptr != 0) {
			for (index = 0; buf_ptr < 64 && index < msglen; index++, buf_ptr++) {
				buffer[buf_ptr] = input[index];
			}

			if (buf_ptr < 64) {
				if (rem != 0) {

					bits_in_last_byte = rem;
					buffer[buf_ptr++] = input[index];
				}

			}

			buf_ptr = 0;
			Transform(buffer, 64, 0);
		}

		Transform(input, msglen - index, index);
		index += ((msglen - index) / 64) * 64;

		for (; index < msglen; index++, buf_ptr++) {
			buffer[buf_ptr] = input[index];
		}

		if (rem != 0) {
			bits_in_last_byte = rem;
			buffer[buf_ptr++] = input[index];
		}

	}

	private static void Transform(byte[] input, int msglen, int offset) {

		int[][] temp1 = new int[8][16];
		int[][] temp2 = new int[8][16];

		for (; msglen >= 64; msglen -= 64, offset += 64) {
			for (int i = 0; i < 8; i++) {
				for (int j = 0; j < 8; j++) {
					temp1[i][j] = chaining[i][j]
							^ input[(j * 8 + i) + offset];
					temp2[i][j] = input[(j * 8 + i) + offset];
				}
			}

			P(temp1);
			Q(temp2);

			for (int i = 0; i < 8; i++) {
				for (int j = 0; j < 8; j++) {
					chaining[i][j] ^= temp1[i][j] ^ temp2[i][j];
				}
			}

			block_counter++;
		}
	}

	private static void OutputTransformation() {

		int[][] temp = new int[8][16];

		for (int i = 0; i < 8; i++) {
			for (int j = 0; j < 8; j++) {
				temp[i][j] = chaining[i][j];
			}
		}

		P(temp);

		for (int i = 0; i < 8; i++) {
			for (int j = 0; j < 8; j++) {
				chaining[i][j] ^= temp[i][j];
			}
		}
	}

	private static void P(int[][] x) {

		for (int i = 0; i < 10; i++) {
			AddRoundConstant(x, i, 0);
			SubBytes(x, 8);
			ShiftBytes(x, 8, 0);
			MixBytes(x, 8);

		}
	}

	private static void Q(int[][] x) {

		for (int i = 0; i < 10; i++) {
			AddRoundConstant(x, i, 1);
			SubBytes(x, 8);
			ShiftBytes(x, 8, 1);
			MixBytes(x, 8);
		}
	}

	private static void AddRoundConstant(int[][] x, int round, int v) {

		switch (v & 1) {
		case 0:
			x[0][0] ^= round;
			break;
		case 1:
			x[8 - 1][0] ^= round ^ 0xFF;
			break;
		}

	}

	private static void SubBytes(int[][] x, int columns) {

		for (int i = 0; i < 8; i++)
			for (int j = 0; j < columns; j++) {
				x[i][j] = S[(x[i][j]) & 255];
			}
	}

	private static void ShiftBytes(int[][] x, int columns, int v) {
		
		int[] R = Shift[v / 2];
		int[] temp = new int[16];

		for (int i = 0; i < 8; i++) {
			for (int j = 0; j < columns; j++) {
				temp[j] = x[i][(j + R[i]) % columns];
			}
			for (int j = 0; j < columns; j++) {
				x[i][j] = temp[j];
			}
		}
	}

	private static void MixBytes(int[][] x, int columns) {

		int[] temp = new int[8];
		for (int i = 0; i < columns; i++) {
			for (int j = 0; j < 8; j++) {
				temp[j] = mul2(x[(j + 0) % 8][i])
						^ mul2(x[(j + 1) % 8][i])
						^ mul3(x[(j + 2) % 8][i])
						^ mul4(x[(j + 3) % 8][i])
						^ mul5(x[(j + 4) % 8][i])
						^ mul3(x[(j + 5) % 8][i])
						^ mul5(x[(j + 6) % 8][i])
						^ mul7(x[(j + 7) % 8][i]);

			}

			for (int j = 0; j < 8; j++) {
				x[j][i] = temp[j] & 255;
			}
		}
	}

}
