public class Luffa {

	private static int[] chainv = new int[40];
	private static int[] buffer = new int[8];
	private static long[] bitlen = new long[2];
	private static int rembitlen;

	public static void Init() {

		System.arraycopy(IV, 0, chainv, 0, 40);
		rembitlen = 0;
		bitlen[0] = 0;
		bitlen[1] = 0;

	}

	public static void Update(byte[] data, long databitlen) {

		int cpylen, len;
		int[] c = new int[10];
		byte[] p = new byte[32];

		bitlen[0] += databitlen;
		int offset = 0;

		if (rembitlen + databitlen >= 256) {
			cpylen = 32 - (rembitlen >> 3);
			System.arraycopy(data, 0, p, rembitlen >> 3, cpylen);
			BYTES_SWAP256(p);
			System.arraycopy(CNS, 0, c, 0, 6);
			rnd(c);
			databitlen -= (cpylen << 3);
			offset += cpylen;
			rembitlen = 0;

			while (databitlen >= 256) {
				System.arraycopy(data, offset, p, 0, 32);
				BYTES_SWAP256(p);
				System.arraycopy(CNS, 0, c, 0, 6);
				rnd(c);
				databitlen -= 256;
				offset += 32;
			}
		}

		if (databitlen != 0) {
			len = (int) (databitlen >> 3);
			if (databitlen % 8 != 0) {
				len += 1;
			}
			System.arraycopy(data, offset, p, rembitlen >> 3, len);
			rembitlen += databitlen;

		}
		syncBuffer(p);
	}

	private static void rnd(int[] c) {

		mi();
		tweak();
		for (int i = 0; i < 8; i++) {
			step(c);
		}
	}

	private static void mi() {

		int[] t = new int[40];

		for (int i = 0; i < 8; i++) {
			t[i] = 0;
			for (int j = 0; j < 3; j++) {
				t[i] ^= chainv[i + 8 * j];
			}
		}
		mult2(t, 0, 0);
		for (int j = 0; j < 3; j++) {
			for (int i = 0; i < 8; i++) {
				chainv[i + 8 * j] ^= t[i];
			}
		}
		for (int j = 0; j < 3; j++) {
			for (int i = 0; i < 8; i++) {
				chainv[i + 8 * j] ^= buffer[i];
			}
			mult2(buffer, 0, 1);

		}

		return;
	}

	private static void mult2(int[] a, int offset, int type) {
		int tmp;

		switch (type) {
		case 0:
			tmp = a[7 + offset];
			a[7 + offset] = a[6 + offset];
			a[6 + offset] = a[5 + offset];
			a[5 + offset] = a[4 + offset];
			a[4 + offset] = a[3 + offset] ^ tmp;
			a[3 + offset] = a[2 + offset] ^ tmp;
			a[2 + offset] = a[1 + offset];
			a[1 + offset] = a[0 + offset] ^ tmp;
			a[0 + offset] = tmp;
			break;
		case 1:
			tmp = buffer[7 + offset];
			buffer[7 + offset] = buffer[6 + offset];
			buffer[6 + offset] = buffer[5 + offset];
			buffer[5 + offset] = buffer[4 + offset];
			buffer[4 + offset] = buffer[3 + offset] ^ tmp;
			buffer[3 + offset] = buffer[2 + offset] ^ tmp;
			buffer[2 + offset] = buffer[1 + offset];
			buffer[1 + offset] = buffer[0 + offset] ^ tmp;
			buffer[0 + offset] = tmp;
			break;
		case 2:
			tmp = chainv[7 + offset];
			chainv[7 + offset] = chainv[6 + offset];
			chainv[6 + offset] = chainv[5 + offset];
			chainv[5 + offset] = chainv[4 + offset];
			chainv[4 + offset] = chainv[3 + offset] ^ tmp;
			chainv[3 + offset] = chainv[2 + offset] ^ tmp;
			chainv[2 + offset] = chainv[1 + offset];
			chainv[1 + offset] = chainv[0 + offset] ^ tmp;
			chainv[0 + offset] = tmp;
			break;
		default:
			break;
		}

		return;
	}

	private static void tweak() {

		for (int j = 0; j < 3; j++) {
			for (int i = 4; i < 8; i++) {
				chainv[(8 * j) + i] = (chainv[(8 * j) + i] << j) | (chainv[(8 * j) + i] >>> (32 - j));
			}
		}

		return;
	}

	private static void step(int[] c) {

		for (int j = 0; j < 3; j++) {
			step_part(8 * j, c, 2 * j);
		}

		return;

	}

	private static void step_part(int a, int[] c, int offset) {

		int[] cns = new int[2];

		subcrumb(a, a + 1, a + 2, a + 3);
		subcrumb(a + 5, a + 6, a + 7, a + 4);

		mixword(0 + a);
		mixword(1 + a);
		mixword(2 + a);
		mixword(3 + a);

		genconstant(c, offset, cns);
		addconstant(a, cns);

		return;
	}

	private static void subcrumb(int a0, int a1, int a2, int a3) {

		int tmp;
		tmp = chainv[a0];

		chainv[a0] |= chainv[a1];
		chainv[a2] ^= chainv[a3];
		chainv[a1] = ~chainv[a1];
		chainv[a0] ^= chainv[a3];
		chainv[a3] &= tmp;
		chainv[a1] ^= chainv[a3];
		chainv[a3] ^= chainv[a2];
		chainv[a2] &= chainv[a0];

		chainv[a0] = ~chainv[a0];
		chainv[a2] ^= chainv[a1];
		chainv[a1] |= chainv[a3];
		tmp ^= chainv[a1];
		chainv[a3] ^= chainv[a2];
		chainv[a2] &= chainv[a1];
		chainv[a1] ^= chainv[a0];
		chainv[a0] = tmp;

		return;
	}

	private static void mixword(int offset) {

		chainv[4 + offset] ^= chainv[0 + offset];
		chainv[0 + offset] = (chainv[0 + offset] << 2) | (chainv[0 + offset] >>> (32 - 2));
		chainv[0 + offset] ^= chainv[4 + offset];
		chainv[4 + offset] = (chainv[4 + offset] << 14) | (chainv[4 + offset] >>> (32 - 14));
		chainv[4 + offset] ^= chainv[0 + offset];
		chainv[0 + offset] = (chainv[0 + offset] << 10) | (chainv[0 + offset] >>> (32 - 10));
		chainv[0 + offset] ^= chainv[4 + offset];
		chainv[4 + offset] = (chainv[4 + offset] << 1) | (chainv[4 + offset] >>> (32 - 1));

	}

	private static void genconstant(int[] c, int offset, int[] cns) {

		if ((c[0 + offset] >>> 31) != 0) {
			c[0 + offset] = (c[0 + offset] << 1) ^ (c[1 + offset] >>> 31) ^ 0xc4d6496c;
			c[1 + offset] = (c[1 + offset] << 1) ^ 0x55c61c8d;
		} else {
			c[0 + offset] = (c[0 + offset] << 1) ^ (c[1 + offset] >>> 31);
			c[1 + offset] <<= 1;
		}
		cns[0] = c[0 + offset];
		c[0 + offset] = c[1 + offset];
		c[1 + offset] = cns[0];
		if ((c[0 + offset] >>> 31) != 0) {
			c[0 + offset] = (c[0 + offset] << 1) ^ (c[1 + offset] >>> 31) ^ 0xc4d6496c;
			c[1 + offset] = (c[1 + offset] << 1) ^ 0x55c61c8d;
		} else {
			c[0 + offset] = (c[0 + offset] << 1) ^ (c[1 + offset] >>> 31);
			c[1 + offset] <<= 1;
		}
		cns[1] = c[0 + offset];
		c[0 + offset] = c[1 + offset];
		c[1 + offset] = cns[1];

		return;
	}

	private static void addconstant(int a, int[] cns) {

		chainv[a + 0] ^= cns[0];
		chainv[a + 4] ^= cns[1];
		return;
	}

	public static void Final(byte[] hashval) {

		process_last_msgs();
		finalization(hashval);

	}

	private static void process_last_msgs() {

		int tail_len, i;
		int[] c = new int[10];
		byte[] tmpbuffer = new byte[32];

		tail_len = (int) (bitlen[0] % 256);
		setByteBuffer(tmpbuffer);
		tail_len = (int) (bitlen[0] % 256);
		i = tail_len / 8;
		if (tail_len % 8 == 0) {
			tmpbuffer[i] = (byte) 0x80;
		} else {
			tmpbuffer[i] &= (byte) (0xff << 8 - (tail_len % 8)) & 255;
			tmpbuffer[i] |= (byte) (0x80 >>> tail_len % 8) & 255;
		}
		i++;
		for (; i < 32; i++)
			tmpbuffer[i] = 0;
		BYTES_SWAP256(tmpbuffer);
		for (i = 0; i < 6; i++)
			c[i] = CNS[i];
		rnd(c);
		return;
	}

	private static void BYTES_SWAP256(byte[] tmpbuffer) {
		int a = 0;
		for (int j = 0; j < buffer.length; j++) {
			int value;
			value = (tmpbuffer[a++] & 255) << 24;
			value |= (tmpbuffer[a++] & 255) << 16;
			value |= (tmpbuffer[a++] & 255) << 8;
			value |= (tmpbuffer[a++] & 255) << 0;
			buffer[j] = value;
		}

	}

	private static void syncBuffer(byte[] p) {
		int a = 0;
		for (int j = 0; j < buffer.length; j++) {
			int value;
			value = (p[a++] & 255) << 0;
			value |= (p[a++] & 255) << 8;
			value |= (p[a++] & 255) << 16;
			value |= (p[a++] & 255) << 24;
			buffer[j] = value;
		}

	}

	private static void setByteBuffer(byte[] p) {
		int a = 0;
		for (int i = 0; i < 8; i++) {
			p[a++] = (byte) (buffer[i] >>> 0);
			p[a++] = (byte) (buffer[i] >>> 8);
			p[a++] = (byte) (buffer[i] >>> 16);
			p[a++] = (byte) (buffer[i] >>> 24);
		}
	}

	private static void finalization(byte[] b) {
		int i;
		int[] c = new int[10];
		int b_tmp[] = new int[b.length];

		for (int k = 0; k < 8; k++) {
			c[k] = CNS[k];
			buffer[k] = 0;
		}
		for (int p = 0; p < 8; p++) {
			buffer[p] = 0;
		}
		rnd(c);
		for (i = 0; i < 8; i++) {
			b_tmp[i] = 0;
			for (int j = 0; j < 3; j++) {
				b_tmp[i] ^= chainv[i + 8 * j];
			}
		}
		i = 0;
		for (int k = 0; k < 8; k++) {
			b[i++] = (byte) (b_tmp[k] >> 24);
			b[i++] = (byte) (b_tmp[k] >> 16);
			b[i++] = (byte) (b_tmp[k] >> 8);
			b[i++] = (byte) (b_tmp[k] >> 0);
		}

	}

	public static void Hash(byte[] data, long databitlen, byte[] hashval) {

		Init();
		Update(data, databitlen);
		Final(hashval);

	}

	private static final int[] IV = { 0x6d251e69, 0x44b051e0, 0x4eaa6fb4, 0xdbf78465, 0x6e292011, 0x90152df4,
			0xee058139, 0xdef610bb, 0xc3b44b95, 0xd9d2f256, 0x70eee9a0, 0xde099fa3, 0x5d9b0557, 0x8fc944b3,
			0xcf1ccf0e, 0x746cd581, 0xf7efc89d, 0x5dba5781, 0x04016ce5, 0xad659c05, 0x0306194f, 0x666d1836,
			0x24aa230a, 0x8b264ae7, 0x858075d5, 0x36d79cce, 0xe571f7d7, 0x204b1f67, 0x35870c6a, 0x57e9e923,
			0x14bcb808, 0x7cde72ce, 0x6c68e9be, 0x5ec41e22, 0xc825b7c7, 0xaffb4363, 0xf5df3999, 0x0fc688f1,
			0xb07224cc, 0x03e86cea };

	private static final int[] CNS = { 0x181cca53, 0x380cde06, 0x5b6f0876, 0xf16f8594, 0x7e106ce9,
			0x38979cb0, 0xbb62f364, 0x92e93c29, 0x9a025047, 0xcff2a940 };

}
