public class Shabal {

	private static final int sM = 16;
	private static final int nR = 12;
	private static int[] A;
	private static int[] B;
	private static int[] C;

	private static int Whigh, Wlow, last_byte_significant_bits, buffer_ptr;
	private static int[] buffer = new int[64];

	public static void Update(byte[] data, long databitlen) {

		int dataPointer = 0;
		int len, ptr;

		last_byte_significant_bits = (int) (databitlen & 0x07);
		len = (int) (databitlen >> 3);
		ptr = buffer_ptr;

		while (len > 0) {
			int clen;

			clen = (buffer.length) - ptr;

			if (clen > len)
				clen = len;

			for (int i = 0; i < clen; i++)
				buffer[i + ptr] = data[dataPointer + i] & 255;

			ptr += clen;

			dataPointer += clen;
			len -= clen;
			if (ptr == buffer.length) {
				int[] m = new int[sM];
				decode_block(m);
				input_block_add(m);
				xor_counter();
				apply_perm(m);
				input_block_sub(m);
				swap_bc();
				incr_counter();
				ptr = 0;
			}
		}
		if (last_byte_significant_bits != 0) {
			buffer[ptr] = data[dataPointer] & 255;
		}
		buffer_ptr = ptr;
	}

	public static void Final(byte[] hashval) {

		int ptr;
		int lbsb;
		int[] m = new int[sM];
		int i;

		ptr = buffer_ptr;
		lbsb = last_byte_significant_bits;
		buffer[ptr] = ((buffer[ptr] & ~(0x7F >>> lbsb)) | (0x80 >>> lbsb));
		for (int j = 0; j < buffer.length - (ptr + 1); j++) {
			buffer[j + 1 + ptr] = 0;
		}

		decode_block(m);
		input_block_add(m);
		xor_counter();
		apply_perm(m);
		for (i = 0; i < 3; i++) {
			swap_bc();
			xor_counter();
			apply_perm(m);
		}
		int index = 0;
		int tmp;
		for (i = sM - (256 >>> 5); i < sM; i++) {
			tmp = B[i];
			hashval[index++] = (byte) (tmp & 0xff);
			hashval[index++] = (byte) ((tmp >>> 8) & 0xff);
			hashval[index++] = (byte) ((tmp >>> 16) & 0xff);
			hashval[index++] = (byte) ((tmp >>> 24) & 0xff);
		}

	}

	private static void decode_block(int[] m) {

		for (int i = 0, j = 0; i < sM; i++, j += 4) {
			m[i] = buffer[j] + (buffer[j + 1] << 8) + (buffer[j + 2] << 16) + (buffer[j + 3] << 24);
		}

	}

	public static void Init() {

		int[] m = new int[sM];
		A = new int[12];
		B = new int[16];
		C = new int[16];

		Wlow = 0xffffffff;
		Whigh = 0xffffffff;

		for (int j = 0; j < (2 * sM); j += sM) {
			for (int i = 0; i < sM; i++)
				m[i] = 256 + j + i;

			input_block_add(m);
			xor_counter();
			apply_perm(m);
			input_block_sub(m);
			swap_bc();
			incr_counter();
		}

		buffer_ptr = 0;
	}

	public static void Hash(byte[] data, long databitlen, byte[] hashval) {

		Init();
		Update(data, databitlen);
		Final(hashval);

	}

	private static void incr_counter() {
		if ((Wlow = T32(Wlow + 1)) == 0)
			Whigh++;

	}

	private static void swap_bc() {
		int t;
		for (int i = 0; i < sM; i++) {
			t = B[i];
			B[i] = C[i];
			C[i] = t;
		}
	}

	private static void input_block_sub(int[] m) {
		for (int i = 0; i < sM; i++)
			C[i] = T32(C[i] - m[i]);
	}

	private static void input_block_add(int[] m) {
		for (int i = 0; i < sM; i++) {
			B[i] = T32(B[i] + m[i]);
		}
	}

	private static int T32(int x) {
		return (x & 0xFFFFFFFF);
	}

	private static int xA(int i, int j) {
		return A[(i + sM * j) % nR];
	}

	private static int xAm1(int i, int j) {
		return (A[(i + sM * j + (nR - 1)) % nR]);
	}

	private static int U(int x) {
		return T32(3 * (x));
	}

	private static int V(int x) {
		return T32(5 * (x));
	}

	private static void xor_counter() {
		A[0] ^= Wlow;
		A[1] ^= Whigh;

	}

	private static void apply_perm(int[] m) {
		int i, j;
		int xAm1, xA;
		for (i = 0; i < sM; i++) {
			int t;
			t = B[i];
			B[i] = (T32(t << 17) | (t >>> 15));
		}

		for (j = 0; j < 3; j++) {
			for (i = 0; i < sM; i++) {
				int tB;

				xA = xA(i, j);
				xAm1 = xAm1(i, j);
				xA = U(xA ^ V(T32(xAm1 << 15) | (xAm1 >>> 17)) ^ C[(8 + sM - i) % sM]) ^ B[(i + 13) % sM]
						^ (B[(i + 9) % sM] & ~B[(i + 6) % sM]) ^ m[i];
				A[(i + sM * j) % nR] = xA;
				A[(i + sM * j + (nR - 1)) % nR] = xAm1;
				tB = B[i];
				B[i] = T32(((tB << 1) | (tB >>> 31)) ^ ~xA);
			}
		}

		for (j = 0; j < (3 * nR); j++) {
			A[(3 * nR - 1 - j) % nR] = T32(A[(3 * nR - 1 - j) % nR] + C[(3 * nR * sM + 6 - j) % sM]);
		}
	}
}
